-- Whlt aus drei Werten den mittleren aus.

LIBRARY ieee;
use ieee.std_logic_1164.all;

ENTITY ba_median3 IS
  PORT(
  A, B, C : in std_logic_vector (11 downto 0);
  M : out std_logic_vector (11 downto 0)
  );
END ba_median3;

ARCHITECTURE name OF ba_median3 IS

  SIGNAL ss1, ss2, ss3 : std_logic;
  signal select_signal: std_logic_vector (2 downto 0);

BEGIN

  ss1 <= '1' when A > B else '0';
  ss2 <= '1' when B > C else '0';
  ss3 <= '1' when C > A else '0';
  select_signal <= (ss1, ss2, ss3);

  with select_signal select
   M <= A when "000", -- egal weil alle gleich
        B when "001",
        A when "010",
        C when "011",
        C when "100",
        A when "101",
        B when "110",
        (others => 'X') when others;--"111"; darf nicht; Am besten wre es hier einfach A zu nehmen

END ARCHITECTURE name;